# The Orchard Book

[Orchard](README.md)
- [Concepts](concepts.md)
  - [Preliminaries](concepts/preliminaries.md)
- [User Documentation](user.md)
  - [Creating keys and addresses](user/keys.md)
  - [Creating notes](user/creating-notes.md)
  - [Spending notes](user/spending-notes.md)
  - [Integration into an existing chain](user/integration.md)
- [Design](design.md)
  - [Keys and addresses](design/keys.md)
  - [Actions](design/actions.md)
  - [Commitments](design/commitments.md)
  - [Commitment tree](design/commitment-tree.md)
  - [Nullifiers](design/nullifiers.md)
  - [Signatures](design/signatures.md)
  - [Circuit](design/circuit.md)
    - [Gadgets](design/circuit/gadgets.md)
      - [Elliptic curve cryptography](design/circuit/gadgets/ecc.md)
        - [Incomplete and complete addition](design/circuit/gadgets/ecc/addition.md)
        - [Fixed-base scalar multiplication](design/circuit/gadgets/ecc/fixed-base-scalar-mul.md)
        - [Variable-base scalar multiplication](design/circuit/gadgets/ecc/var-base-scalar-mul.md)
      - [Sinsemilla](design/circuit/gadgets/sinsemilla.md)
        - [MerkleCRH](design/circuit/gadgets/sinsemilla/merkle-crh.md)
        - [CommitIvk](design/circuit/gadgets/sinsemilla/commit-ivk.md)
        - [NoteCommit](design/circuit/gadgets/sinsemilla/note-commit.md)
      - [Decomposition](design/circuit/gadgets/decomposition.md)
